
// uCalcDemoVC_MFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "uCalcDemoVC_MFC.h"
#include "uCalcDemoVC_MFCDlg.h"
#include "afxdialogex.h"
#include "uCalc.h"
#include  <cmath>
#include  <ctime>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CuCalcDemoVC_MFCDlg dialog
double W, H;
CString UserFormat;

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall MyErrorHandler(uCalcPtr uCalcHandle)
{
	auto uc = uCalc(uCalcHandle);
	static bool DisplayAgain = true;
	CString ErrorNumber; ErrorNumber.Format(CString("%d"), uc.ErrorNumber());
	CString ErrorLocation; ErrorNumber.Format(CString("%d"), uc.ErrorLocation());

	if (DisplayAgain) {	   
		auto Option =  MessageBox(0, CString("") +
			"uCalc Error (this message box is part of the demo)\n\n"
			"Error Number: " + ErrorNumber + "\n"
			"Bad expression: " + uc.ErrorExpression() + "\n"
			"Error Handler message: " + uc.ErrorMessage() + "\n"
			"Offending symbol: " + uc.ErrorSymbol() + "\n"
			"Error Location: " + ErrorLocation + "\n\n"
			"See MyErrorHandler(), in MyFunctions.vb, for error handler source code.\n\n"
			"Show this message next time?", CString("uCalc Error (this message box is part of the demo)"), MB_YESNOCANCEL);
		if (Option == IDNO) DisplayAgain = false;
	}
}

void _stdcall MyNumericFormat(uCalcPtr ExprPartPtr) {
	auto uc = uCalc::Callback(ExprPartPtr);
	CString Value = uc.ArgStr(1);
	if (Value.Find(_T("#")) == -1) Value.Format(UserFormat, atof(CStringA(Value)));
	uc.ReturnStr(Value);		
}

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall MyArea(uCalcPtr ExprPartPtr)
{
	auto uc = uCalc::Callback(ExprPartPtr);
	auto MyLength = uc.Arg(1);
	auto MyWidth = uc.Arg(2);			

	if(MyLength < 0) uc.ErrorRaiseMessage("Length cannot be negative");
	if(MyWidth  < 0) uc.ErrorRaiseMessage("Width cannot be negative");

	uc.Return(MyLength * MyWidth);
}

/* +++
// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
long double _stdcall NonNativeFunc(double a, long& b, byte c)
{
return a + b + c;
}
*/

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall MyIIF_Numeric(uCalcPtr ExprPartPtr)
{
	auto uc = uCalc::Callback(ExprPartPtr);
	auto Condition = uc.Arg(1);
	auto TruePart = uc.ArgExpr(2);
	auto FalsePart = uc.ArgExpr(3);

	if(Condition != 0)
		uc.Return(TruePart.Evaluate());
	else 
		uc.Return(FalsePart.Evaluate());
}

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall MyIIF_String(uCalcPtr ExprPartPtr)
{
	auto uc = uCalc::Callback(ExprPartPtr);
	auto Condition = uc.Arg(1);
	auto TruePart = uc.ArgExpr(2);
	auto FalsePart = uc.ArgExpr(3);

	if(Condition != 0)
		uc.ReturnStr(TruePart.EvaluateStr());
	else 
		uc.ReturnStr(FalsePart.EvaluateStr());
}

/* +++
// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall Native_MsgBox(DWORD Expr)
{
// The 2nd and 3rd args are swapped so that MsgBox is uniform with the demo for VB and other compilers
ucReturn(MessageBox(0, ucParamStr(1), ucParamStr(3), ucParam(2)));
}

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
long _stdcall MyMsgBox(long Prompt, long Buttons, long Title)
{
return MessageBox(0, ucEvaluateStr(Prompt), ucEvaluateStr(Title), Buttons);
}

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
long _stdcall nn_MsgBox(CString& Prompt, long Buttons, CString& Title)
{
return MessageBox(0, Prompt, Title, Buttons);
}
*/

int MessageBoxQ(int ignore, CStringA a1, CStringA a2, UINT a3) { return MessageBoxA(0, a1, a2, a3); }
int MessageBoxQ(int ignore, CStringW a1, CStringW a2, UINT a3) { return MessageBoxW(0, a1, a2, a3); }
// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall MyMsgBox(uCalcPtr ExprPartPtr)
{
	auto uc = uCalc::Callback(ExprPartPtr); // Args 2 & 3 inverted because it's based on VB MsgBox syntax
	uc.Return(MessageBoxQ(0, uc.ArgStr(1), uc.ArgStr(3), uc.Arg(2)));	
}


// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall MyAverage(uCalcPtr ExprPartPtr)
{
	auto uc = uCalc::Callback(ExprPartPtr);
	double Total = 0;

	for(int x=1; x <= uc.ArgCount(); x++)
		Total = Total + uc.Arg(x);        

	uc.Return(Total / uc.ArgCount());
}

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall MyLeft(uCalcPtr ExprPartPtr)
{
	auto uc = uCalc::Callback(ExprPartPtr);
	uc.ReturnStr(uc.ArgStr(1).Left(uc.Arg(2)));
}

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall StringRepeat(uCalcPtr ExprPartPtr)
{   
	auto uc = uCalc::Callback(ExprPartPtr);
	CString TotalString = CString("");

	for(int x = 1; x <= uc.Arg(2); x++)
		TotalString = TotalString + uc.ArgStr(1);

	uc.ReturnStr(TotalString);
}

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall ucSum(uCalcPtr ExprPartPtr)
{
	auto uc = uCalc::Callback(ExprPartPtr);
	double Total = 0;

	auto Expression = uc.ArgExpr(1);
	auto Start = uc.Arg(2);
	auto Finish = uc.Arg(3);
	auto sStep = uc.Arg(4);
	auto VarHandle = uc.ArgObj(5);

	for (double x = Start; x <= Finish; x += sStep) 
	{
		VarHandle.SetVariableValue(x);
		Total = Total + Expression.Evaluate();
		x = x + sStep;
	}

	uc.Return(Total);   
}

// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
void _stdcall ucSolve(uCalcPtr ExprPartPtr)
{
	auto uc = uCalc::Callback(ExprPartPtr);
	int Iterations = 0;
	double fa, fb, Value = 0, tmp;

	auto Expression = uc.ArgExpr(1);
	auto a = uc.Arg(2);
	auto b = uc.Arg(3);
	auto Variable = uc.ArgObj(4);			

	Variable.SetVariableValue(a);
	fa = Expression.Evaluate();

	Variable.SetVariableValue(b);
	fb = Expression.Evaluate();

	if(fb < fa) {tmp = a; a = b; b = tmp;}  // swap a, b

	while(abs(b - a) > 0.000000000000001)
	{
		Variable.SetVariableValue((a + b) / 2);

		Value = Expression.Evaluate();

		if(Value == 0) {a = (a + b) / 2; break;}

		if(Value < 0) a = (a + b) / 2; else b = (a + b) / 2;

		Iterations = Iterations + 1;
		if(Iterations == 100) break;
	}

	if(abs(Value) > 0.0000000001) uc.ErrorRaiseMessage("Solution not found");
	uc.Return(a);
}

void CartesianLineTo(CDC* pDC, double X, double Y)
{
	int x, y;
	CRect rect;  

	x = (long)(W * (X + 10) / 20);
	y = (long)(H * (2 - Y) / 4);

	if (X == -10 || y > H || y < 0)
		pDC->MoveTo((long)x, (long)min(max(y, 0), H));
	else pDC->LineTo(x, y);  
}

CuCalcDemoVC_MFCDlg::CuCalcDemoVC_MFCDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CuCalcDemoVC_MFCDlg::IDD, pParent)
{	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);	
}

void CuCalcDemoVC_MFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CuCalcDemoVC_MFCDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_btnDefine, &CuCalcDemoVC_MFCDlg::OnBnClickedbtndefine)
	ON_BN_CLICKED(IDC_btnEvaluate, &CuCalcDemoVC_MFCDlg::OnBnClickedbtnevaluate)
	ON_BN_CLICKED(IDC_btnSummation, &CuCalcDemoVC_MFCDlg::OnBnClickedbtnsummation)
	ON_BN_CLICKED(btnPlot, &CuCalcDemoVC_MFCDlg::OnBnClickedbtnplot)
	ON_BN_CLICKED(IDC_CHECK1, &CuCalcDemoVC_MFCDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK2, &CuCalcDemoVC_MFCDlg::OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_CHECK3, &CuCalcDemoVC_MFCDlg::OnBnClickedCheck3)
	ON_BN_CLICKED(IDC_CHECK4, &CuCalcDemoVC_MFCDlg::OnBnClickedCheck4)
	ON_BN_CLICKED(IDC_CHECK5, &CuCalcDemoVC_MFCDlg::OnBnClickedCheck5)
END_MESSAGE_MAP()


// CuCalcDemoVC_MFCDlg message handlers

BOOL CuCalcDemoVC_MFCDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CheckDlgButton(IDC_CHECK4, BST_CHECKED);
	CheckDlgButton(IDC_CHECK5, BST_CHECKED);

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_cmbExpression, CString(".5 + 10"));
	SetDlgItemText(IDC_cmbOutput, CString("%f"));
	SetDlgItemText(IDC_cmbDefine, CString("Var: x = 123"));
	SetDlgItemText(IDC_txtSumMax, CString("100000"));
	SetDlgItemText(IDC_txtSumExpression, CString("x^2+5*x-10"));
	SetDlgItemText(IDC_txtPlotExpression, CString("-sin(x)/2"));

	// The MyErrorHandler() function will be called whenever and wherever an error (such as "Syntax Error") is raised.	
	uc.AddErrorHandler(MyErrorHandler);

	// SetOutput lets you configure the formatting of results returned with EvalStr() or EvaluateStr()
	uc.SetOutput(MyNumericFormat, "Double");

	// MyArea() returns the product of multiplying the two arguments.
	// MyLeft() returns the left-most characters of a string.  The second argument represents the number of characters.
	// MsgBox() displays a message box.  The 1st argument is required.  The others are optional.
	uc.DefineFunction("MyArea(Length, Width)", MyArea);	
	uc.DefineFunction("MyLeft(Text As String, Count) As String", MyLeft);
	uc.DefineFunction("MyMsgBox(Prompt As String, Buttons = 0, Title As String = 'uCalc')", MyMsgBox);
	uc.DefineSyntax("MsgBox ::= MyMsgBox");

	// The three consecutive dots "..." mean that MyAverage can take any number of arguments
	// (however, because "x" is specified, there must be at least one argument).
	uc.DefineFunction("MyAverage(x ...)", MyAverage);

	// Two versions of MyIIF can co-exist peacefully with the same name because
	// they are defined with different argument types (numeric vs string).
	// By passing the last two arguments ByExpr, the callback can chose to evaluate only one of of them.  
	uc.DefineFunction("MyIIf(cond, ByExpr TruePart, ByExpr FalsePart)", MyIIF_Numeric);
	uc.DefineFunction("MyIIf(cond, ByExpr TruePart As String, ByExpr FalsePart As String) As String", MyIIF_String);

	// The following defines the "*" operator so that MyString * n returns MyString repeated n times.
	// For instance, "He " * 3, would return "He He He".  20 represents the precedence level.  It is
	// arbitrarily set at the same level as that of the numeric "*" multiplication operator.
	uc.DefineOperator("{MyString As String} * {Number} As String", uCalc::Item(uc.HandleOf(CString("*"))).Precedence(), GroupLeftToRight, StringRepeat);

	// This definition is for a summation.  See the callback ucSum() routine for the
	// actual code, which runs a loop that adds up the total for the expression in
	// the first argument a number of times based on the second and third arguments.
	// For instance Sum(g^2+1, 1, 5, 1, g) returns 60 and Sum(x^2, 1, 10) returns 385.
	// The last two arguments are optional, so they default to 1 and x if omitted.
	//
	// The first argument is passed "ByExpr".  So instead of being evaluated before
	// being passed to the callback the way an ordinary argument would be, a handle
	// for the expression is passed so that the callback can evaluate it (in this
	// case numerous times).
	//
	// The last argument is passed "ByHandle".  This causes the callback to receive
	// a handle for the variable being passed, in such a way that it can be linked to
	// the summation counter, and integrated into the expression in the first argument.
	//
	// The actual function being defined is Sum_().  Then a syntax construct named
	// Sum() is defined in such a way that the last argument gets defined as a local
	// variable.  So if you evaluate Sum(x^2, 5, 10, 1, x), the local "x" in this
	// expression will not interfere with a pre-existing variable named x.  Also you
	// do not need to declare a variable ahead of time to use it as a counter for Sum().
	uc.DefineFunction("Sum_(ByExpr Expr, Start, Finish, Step, ByHandle Var)", ucSum);
	uc.DefineSyntax("Sum({Expr}, {Start}, {Finish} [, {Step=1} [, {Var=x}]])"
		"::= Local({Var}, Sum_({Expr}, {Start}, {Finish}, {Step}, {Var}))");

	// The following routine solves an equation.
	// The callback code is based on the Bisection Method algorithm.
	// The concept here is very similar to that of Sum().
	// Two syntax constructs are defined.  The second one rearranges the equation
	// if it includes an equal sign.
	// For instance Solve(x^2 = 9+x) becomes Solve(x^2 - (9+x))
	// Solve(x^2 + 1 = 26) returns 5.
	// Solve(x^2 + 1 = 26, -1000, 0) returns -5.
	uc.DefineFunction("Solve_(ByExpr Expr, a, b, ByHandle Var)", ucSolve);
	uc.DefineSyntax("Solve({Expr} [, {a=-100000000} [, {b=100000000} [, {Var=x}]]]) "
		"::= Local({Var}, Solve_({Expr}, {a}, {b}, {Var}))");
	uc.DefineSyntax("Solve({Left} = {Right} [, {etc}]) ::= Solve({Left}-({Right}) {etc: , {etc}})");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CuCalcDemoVC_MFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CuCalcDemoVC_MFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CuCalcDemoVC_MFCDlg::OnBnClickedbtndefine()
{
	// Define() can define a variable, function, operator, syntax construct,
	// constant, pattern, data type, and more.
	CString MyText;
	GetDlgItemText(IDC_cmbDefine, MyText);
	uc.Define(MyText);
}


void CuCalcDemoVC_MFCDlg::OnBnClickedbtnevaluate()
{
	// Eval() evaluates an expression and returns a numeric result.
	// EvalStr() can evaluate expressions of any data type (numeric, string, or other).
	// EvalStr() conveniently converts numeric results to strings for you.
	// EvalStr() can also return the text of an error message.
	GetDlgItemText(IDC_cmbOutput, UserFormat);
	CString Expression;
	GetDlgItemText(IDC_cmbExpression, Expression);
	SetDlgItemText(IDC_txtResult, uc.EvalStr(Expression));
}


void CuCalcDemoVC_MFCDlg::OnBnClickedbtnsummation()
{
	CString txtSumMax; GetDlgItemText(IDC_txtSumMax, txtSumMax);
	CString txtSumExpression; GetDlgItemText(IDC_txtSumExpression, txtSumExpression);
	clock_t BeginTimer = clock();
	double x, SumTotal = 0, SumMax = _ttol(txtSumMax);	

	auto Variable = uc.DefineVariable("x", &x);
	auto Expression = uc.Parse(txtSumExpression);

	for(x = 1; x <= SumMax; x++)
	{
		//Variable.SetVariableValue(x);
		SumTotal = SumTotal + Expression.Evaluate();                
	}

	Expression.Release();
	Variable.Release();  			

	CString strSumTotal; strSumTotal.Format(CString("%4.2f"), SumTotal);
	CString strElapsed; strElapsed.Format(CString("Elapsed time: %4.2f seconds"), double(clock()-BeginTimer) / CLOCKS_PER_SEC);
	SetDlgItemText(IDC_txtSumResult, strSumTotal);
	SetDlgItemText(IDC_lblElapsed, strElapsed);   
}


void CuCalcDemoVC_MFCDlg::OnBnClickedbtnplot()
{
	CRect rect;
	CWnd* h = GetDlgItem(IDC_pctPlotArea);
	h->GetClientRect(rect);
	CDC* pDC = h->GetDC();
	h->GetClientRect(rect);
	pDC->FillRect(rect, CBrush::FromHandle((HBRUSH)GetStockObject(LTGRAY_BRUSH)));  
	W = rect.Width();
	H = rect.Height();
	pDC->MoveTo(0, (long)H/2);


	CString txtPlotExpression; GetDlgItemText(IDC_txtPlotExpression, txtPlotExpression);

	auto Variable = uc.DefineVariable("x");
	auto Equation = uc.Parse(txtPlotExpression);           

	for(double x = -10; x <= 10; x += 0.125)
	{
		Variable.SetVariableValue(x);                
		CartesianLineTo(pDC, x, Equation.Evaluate());                
	}

	Equation.Release();
	Variable.Release();   
}

void CuCalcDemoVC_MFCDlg::OnBnClickedCheck1()
{
	uc.FPEnvToggleExceptionMask(Invalid);
}

void CuCalcDemoVC_MFCDlg::OnBnClickedCheck2()
{
	uc.FPEnvToggleExceptionMask(DivisionByZero);
}

void CuCalcDemoVC_MFCDlg::OnBnClickedCheck3()
{
	uc.FPEnvToggleExceptionMask(Overflow);
}


void CuCalcDemoVC_MFCDlg::OnBnClickedCheck4()
{
	uc.FPEnvToggleExceptionMask(Underflow);
}


void CuCalcDemoVC_MFCDlg::OnBnClickedCheck5()
{
	uc.FPEnvToggleExceptionMask(Inexact);
}
